<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDtoNewPlate ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfDtoNewPlate
 * @subpackage Arrays
 */
class ArrayOfDtoNewPlate extends AbstractStructArrayBase
{
    /**
     * The DtoNewPlate
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DtoNewPlate[]
     */
    public $DtoNewPlate;
    /**
     * Constructor method for ArrayOfDtoNewPlate
     * @uses ArrayOfDtoNewPlate::setDtoNewPlate()
     * @param \StructType\DtoNewPlate[] $dtoNewPlate
     */
    public function __construct(array $dtoNewPlate = array())
    {
        $this
            ->setDtoNewPlate($dtoNewPlate);
    }
    /**
     * Get DtoNewPlate value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DtoNewPlate[]|null
     */
    public function getDtoNewPlate()
    {
        return isset($this->DtoNewPlate) ? $this->DtoNewPlate : null;
    }
    /**
     * Set DtoNewPlate value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\DtoNewPlate[] $dtoNewPlate
     * @return \ArrayType\ArrayOfDtoNewPlate
     */
    public function setDtoNewPlate(array $dtoNewPlate = array())
    {
        foreach ($dtoNewPlate as $arrayOfDtoNewPlateDtoNewPlateItem) {
            // validation for constraint: itemType
            if (!$arrayOfDtoNewPlateDtoNewPlateItem instanceof \StructType\DtoNewPlate) {
                throw new \InvalidArgumentException(sprintf('The DtoNewPlate property can only contain items of \StructType\DtoNewPlate, "%s" given', is_object($arrayOfDtoNewPlateDtoNewPlateItem) ? get_class($arrayOfDtoNewPlateDtoNewPlateItem) : gettype($arrayOfDtoNewPlateDtoNewPlateItem)), __LINE__);
            }
        }
        if (is_null($dtoNewPlate) || (is_array($dtoNewPlate) && empty($dtoNewPlate))) {
            unset($this->DtoNewPlate);
        } else {
            $this->DtoNewPlate = $dtoNewPlate;
        }
        return $this;
    }
    /**
     * Add item to DtoNewPlate value
     * @throws \InvalidArgumentException
     * @param \StructType\DtoNewPlate $item
     * @return \ArrayType\ArrayOfDtoNewPlate
     */
    public function addToDtoNewPlate(\StructType\DtoNewPlate $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DtoNewPlate) {
            throw new \InvalidArgumentException(sprintf('The DtoNewPlate property can only contain items of \StructType\DtoNewPlate, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->DtoNewPlate[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\DtoNewPlate|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\DtoNewPlate|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\DtoNewPlate|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\DtoNewPlate|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\DtoNewPlate|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DtoNewPlate
     */
    public function getAttributeName()
    {
        return 'DtoNewPlate';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfDtoNewPlate
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
