<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPositionTraceExternalId ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfPositionTraceExternalId
 * @subpackage Arrays
 */
class ArrayOfPositionTraceExternalId extends AbstractStructArrayBase
{
    /**
     * The PositionTraceExternalId
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\PositionTraceExternalId[]
     */
    public $PositionTraceExternalId;
    /**
     * Constructor method for ArrayOfPositionTraceExternalId
     * @uses ArrayOfPositionTraceExternalId::setPositionTraceExternalId()
     * @param \StructType\PositionTraceExternalId[] $positionTraceExternalId
     */
    public function __construct(array $positionTraceExternalId = array())
    {
        $this
            ->setPositionTraceExternalId($positionTraceExternalId);
    }
    /**
     * Get PositionTraceExternalId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\PositionTraceExternalId[]|null
     */
    public function getPositionTraceExternalId()
    {
        return isset($this->PositionTraceExternalId) ? $this->PositionTraceExternalId : null;
    }
    /**
     * Set PositionTraceExternalId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\PositionTraceExternalId[] $positionTraceExternalId
     * @return \ArrayType\ArrayOfPositionTraceExternalId
     */
    public function setPositionTraceExternalId(array $positionTraceExternalId = array())
    {
        foreach ($positionTraceExternalId as $arrayOfPositionTraceExternalIdPositionTraceExternalIdItem) {
            // validation for constraint: itemType
            if (!$arrayOfPositionTraceExternalIdPositionTraceExternalIdItem instanceof \StructType\PositionTraceExternalId) {
                throw new \InvalidArgumentException(sprintf('The PositionTraceExternalId property can only contain items of \StructType\PositionTraceExternalId, "%s" given', is_object($arrayOfPositionTraceExternalIdPositionTraceExternalIdItem) ? get_class($arrayOfPositionTraceExternalIdPositionTraceExternalIdItem) : gettype($arrayOfPositionTraceExternalIdPositionTraceExternalIdItem)), __LINE__);
            }
        }
        if (is_null($positionTraceExternalId) || (is_array($positionTraceExternalId) && empty($positionTraceExternalId))) {
            unset($this->PositionTraceExternalId);
        } else {
            $this->PositionTraceExternalId = $positionTraceExternalId;
        }
        return $this;
    }
    /**
     * Add item to PositionTraceExternalId value
     * @throws \InvalidArgumentException
     * @param \StructType\PositionTraceExternalId $item
     * @return \ArrayType\ArrayOfPositionTraceExternalId
     */
    public function addToPositionTraceExternalId(\StructType\PositionTraceExternalId $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PositionTraceExternalId) {
            throw new \InvalidArgumentException(sprintf('The PositionTraceExternalId property can only contain items of \StructType\PositionTraceExternalId, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->PositionTraceExternalId[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\PositionTraceExternalId|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\PositionTraceExternalId|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\PositionTraceExternalId|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\PositionTraceExternalId|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\PositionTraceExternalId|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PositionTraceExternalId
     */
    public function getAttributeName()
    {
        return 'PositionTraceExternalId';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfPositionTraceExternalId
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
