<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for NotifyPositions StructType
 * @subpackage Structs
 */
class NotifyPositions extends AbstractStructBase
{
    /**
     * The positions
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfPositionTrace
     */
    public $positions;
    /**
     * Constructor method for NotifyPositions
     * @uses NotifyPositions::setPositions()
     * @param \ArrayType\ArrayOfPositionTrace $positions
     */
    public function __construct(\ArrayType\ArrayOfPositionTrace $positions = null)
    {
        $this
            ->setPositions($positions);
    }
    /**
     * Get positions value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfPositionTrace|null
     */
    public function getPositions()
    {
        return isset($this->positions) ? $this->positions : null;
    }
    /**
     * Set positions value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfPositionTrace $positions
     * @return \StructType\NotifyPositions
     */
    public function setPositions(\ArrayType\ArrayOfPositionTrace $positions = null)
    {
        if (is_null($positions) || (is_array($positions) && empty($positions))) {
            unset($this->positions);
        } else {
            $this->positions = $positions;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\NotifyPositions
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
